#include "Netzwerk.h"
#include <main.h>
#include <Datei.h>
#include <Fenster.h>
#include <Globals.h>
#include <InitDatei.h>
#include "Keys.h"

int KSGStart Framework::Start( Startparam p )
{
	Network::Start( 10 );
	char serverReturn = 0;

	HANDLE Mutex = OpenMutex( MUTEX_ALL_ACCESS, false, "KSG_Client" );
	if( Mutex == NULL )
	{
		Mutex = CreateMutex( NULL, true, "KSG_Client" );
		DateiRemove( new Text( "data/tmp/k.id" ) );
		DateiRemove( new Text( "data/tmp/keinabsturz" ) );
	}
	else
	{
		WMessageBox( 0, new Text( "Fehler" ), new Text( "Das Programm luft bereits. Wenn die nicht der Fall ist,\nmusst du den Komputer neu starten." ), MB_ICONERROR );
		Network::Exit();
		return 0;
	}

	if( DateiExistiert( new Text( "data/update/unable/list.patch" ) ) )
	{
		PROCESS_INFORMATION prozessinfo3;
		STARTUPINFO startinfo3;
		ZeroMemory( &startinfo3, sizeof( STARTUPINFOW ) );
		startinfo3.cb = sizeof( STARTUPINFOW );

		if( CreateProcess( 0, "data/patch/bin/bernehmen.exe", 0, 0, 0, 0, 0, 0, &startinfo3, &prozessinfo3 ) == 1 )
		{
			Network::Exit();
			DateiRemove( new Text( "data/tmp" ) );
			exit( 0 );
		}
		else
		{
			WMessageBox( 0, new Text( "Fehler" ), new Text( "Bei dem bernehen der nderungen ist ein Fehler aufgetreten.\nBitte starte den Komputer neu. Sollte diese Meldung weiterhin\nerscheinen, so musst du das Spiel neu Installieren." ), MB_ICONERROR );
			exit( 0 );
		}
	}

	PROCESS_INFORMATION prozessinfo1;
	STARTUPINFO startinfo1;
	startinfo1.cb = sizeof( STARTUPINFOW );
	ZeroMemory( &startinfo1, sizeof( STARTUPINFOW ) );
	bool pe = 0;

	if( CreateProcess( 0, "data/start/icon.exe", 0, 0, 0, 0, 0, 0, &startinfo1, &prozessinfo1 ) == 1 )
	{
		CloseHandle( prozessinfo1.hThread );
		pe = 1;
	}

	InitDatei *iDat = new InitDatei( "data/optionen.ini" );
	iDat->laden();
	if( !iDat->zWert( "ServerIP" ) )
		iDat->addWert( "ServerIP", "127.0.0.1" );
	if( !iDat->zWert( "ServerPort" ) )
		iDat->addWert( "ServerPort", "4253" );
	iDat->speichern();
	Text *ipT = iDat->getWert( "ServerIP" );
	unsigned short port = (unsigned short)TextZuInt( iDat->zWert( "ServerPort" )->getText(), 10 );
	iDat->release();
	Klient *klient = new Klient();
    int l = 0;
    char *key;
    Keys::getServerKey( &key, l, Keys::MAIN, Keys::SENDEN );
	klient->setSendeKey( key, l );
    delete[] key;
    Keys::getServerKey( &key, l, Keys::MAIN, Keys::EMPFANGEN );
	klient->setEmpfangKey( key, l );
    delete[] key;
	if( !klient->verbinde( port, ipT->getText() ) )
	{
		Text *message = new Text( "Der Server wurde nicht gefunden.\nServer Ip:" );
		message->append( ipT->getText() );
		message->append( "\nServer Port:" );
		message->append( (int)port );
		WMessageBox( 0, new Text( "Fehler" ), message, MB_ICONERROR );
		ipT->release();
		klient->release();
		Network::Exit();
		return 0;
	}
	klient->sende( "\0", 1 ); // Verschlsselung aktivieren
	klient->sendeEncrypted( "\1\0\0\0\0", 5 );
	char byte = 0;
	klient->getNachrichtEncrypted( &byte, 1 );
	if( byte == 3 )
	{
		klient->getNachrichtEncrypted( &byte, 1 );
		char *message = new char[ byte + 1 ];
		message[ byte ] = 0;
		klient->getNachrichtEncrypted( message, byte );
		Text *nachricht = new Text( "Fehler whrend der Identifikation beim Server.\nServer Rckgabe:\n " );
		nachricht->append( message );
		WMessageBox( 0, new Text( "Server Fehler" ), nachricht, MB_ICONERROR );
		delete[]message;
		ipT->release();
		klient->sendeEncrypted( "\3", 1 );
		klient->getNachrichtEncrypted( &serverReturn, 1 );
		klient->trenne();
		klient->release();
		Network::Exit();
		return 0;
	}
	int klientNummer = 0;
	char *netwSchlssel = 0;
	char netwSchlsselLn = 0;
	if( byte == 1 )
	{
		klient->getNachrichtEncrypted( (char*)&klientNummer, 4 );
		klient->getNachrichtEncrypted( &netwSchlsselLn, 1 );
		if( netwSchlsselLn )
		{
			netwSchlssel = new char[ netwSchlsselLn ];
			klient->getNachrichtEncrypted( netwSchlssel, netwSchlsselLn );
			klient->setSendeKey( netwSchlssel, netwSchlsselLn );
			klient->setEmpfangKey( netwSchlssel, netwSchlsselLn );
			Datei *dat = new Datei();
			dat->setDatei( "data/tmp/schlssel.netw" );
			dat->erstellen();
			dat->open( Datei::Style::schreiben );
			dat->schreibe( &netwSchlsselLn, 1 );
			dat->schreibe( netwSchlssel, netwSchlsselLn );
			dat->close();
			dat->release();
		}
	}
	else
	{
		WMessageBox( 0, new Text( "Server Fehler" ), new Text( "Unbekannte Rckgabe vom Server.\nEventuell ist deine Version des Spiels veraltet." ), MB_ICONERROR );
		ipT->release();
		klient->sendeEncrypted( "\3", 1 );
		klient->getNachrichtEncrypted( &serverReturn, 1 );
		klient->trenne();
		klient->release();
		Network::Exit();
		delete[] netwSchlssel;
		return 0;
	}
	Datei *dat = new Datei();
	dat->setDatei( "data/tmp/k.id" );
	dat->erstellen();
	dat->open( Datei::Style::schreiben );
	dat->schreibe( (char*)&klientNummer, 4 );
	dat->close();
	dat->release();
	klient->sendeEncrypted( "\3", 1 );
	klient->getNachrichtEncrypted( &serverReturn, 1 );
	klient->trenne();
	klient->release();

	ErhaltungKlient *erhaltung = new ErhaltungKlient( klientNummer );
	erhaltung->verbinden( port, ipT, netwSchlssel, netwSchlsselLn );

	if( pe )
	{
		while( WaitForSingleObject( prozessinfo1.hProcess, 1000 ) == WAIT_TIMEOUT );
		CloseHandle( prozessinfo1.hProcess );
	}

	PROCESS_INFORMATION prozessinfo2;
	STARTUPINFO startinfo2;
	startinfo2.cb = sizeof( STARTUPINFOW );
	ZeroMemory( &startinfo2, sizeof( STARTUPINFOW ) );

	if( CreateProcess( 0, "data/patch/bin/patcher.exe", 0, 0, 0, 0, 0, 0, &startinfo2, &prozessinfo2 ) == 1 )
	{
		CloseHandle( prozessinfo2.hThread );
		while( WaitForSingleObject( prozessinfo2.hProcess, 5000 ) == WAIT_TIMEOUT );
		unsigned long erfolg = 0;
		GetExitCodeProcess( prozessinfo2.hProcess, &erfolg );
		if( erfolg != 0 && DateiExistiert( new Text( "data/tmp/keinabsturz" ) ) )
		{
			bool gamestart = erfolg == 2;
			if( erfolg == 1 )
			{
				PROCESS_INFORMATION prozessinfo3;
				STARTUPINFO startinfo3;
				startinfo3.cb = sizeof( STARTUPINFOW );
				ZeroMemory( &startinfo3, sizeof( STARTUPINFOW ) );

				if( CreateProcess( 0, "data/patch/bin/bernehmen.exe", 0, 0, 0, 0, 0, 0, &startinfo3, &prozessinfo3 ) == 1 )
				{
					if( DateiExistiert( new Text( "data/tmp/keinabsturz" ) ) )
						erhaltung->abmelden();
					erhaltung->trennen();
					erhaltung->warteAufThread( 5000 );
					erhaltung->release();
					klient = new Klient();
                    int l = 0;
                    char *key;
                    Keys::getServerKey( &key, l, Keys::MAIN, Keys::SENDEN );
                    klient->setSendeKey( key, l );
                    delete[] key;
                    Keys::getServerKey( &key, l, Keys::MAIN, Keys::EMPFANGEN );
                    klient->setEmpfangKey( key, l );
                    delete[] key;
					if( !klient->verbinde( port, ipT->getText() ) )
					{
						WMessageBox( 0, new Text( "Fehler" ), new Text( "Die Verbindung zum Server ist abgebrochen." ), MB_ICONERROR );
						ipT->release();
						klient->release();
						Network::Exit();
						delete[] netwSchlssel;
						return 0;
					}
					klient->sende( "\0", 1 ); // Verschlsselung aktivieren
					klient->sendeEncrypted( "\1", 1 );
					klient->sendeEncrypted( (char*)&klientNummer, 4 );
					klient->getNachrichtEncrypted( &serverReturn, 1 );
					if( serverReturn == 3 )
					{
						klient->getNachrichtEncrypted( &byte, 1 );
						char *message = new char[ byte + 1 ];
						message[ byte ] = 0;
						klient->getNachrichtEncrypted( message, byte );
						Text *nachricht = new Text( "Fehler whrend der Identifikation beim Server.\nServer Rckgabe:\n " );
						nachricht->append( message );
						WMessageBox( 0, new Text( "Server Fehler" ), nachricht, MB_ICONERROR );
						delete[] message;
					}
					else
					{
						klient->setSendeKey( netwSchlssel, netwSchlsselLn );
						klient->setEmpfangKey( netwSchlssel, netwSchlsselLn );
					}
					klient->sendeEncrypted( "\7", 1 );
					klient->getNachrichtEncrypted( &serverReturn, 1 );
					if( serverReturn == 3 )
					{
						klient->getNachrichtEncrypted( &byte, 1 );
						char *message = new char[ byte + 1 ];
						message[ byte ] = 0;
						klient->getNachrichtEncrypted( message, byte );
						Text *nachricht = new Text( "Fehler whrend der Abmeldung beim Server.\nServer Rckgabe:\n " );
						nachricht->append( message );
						WMessageBox( 0, new Text( "Server Fehler" ), nachricht, MB_ICONERROR );
						delete[]message;
					}
					klient->sendeEncrypted( "\3", 1 );
					klient->getNachrichtEncrypted( &serverReturn, 1 );
					klient->trenne();
					ipT->release();
					klient->release();
					Network::Exit();

					DateiRemove( new Text( "data/tmp" ) );

					exit( 0 );
				}
				else
					gamestart = 0;
				if( !gamestart )
					WMessageBox( 0, new Text( "Fehler" ), new Text( "Bei dem bernehen der nderungen ist ein Fehler aufgetreten." ), MB_ICONERROR );
			}
			if( gamestart )
			{
				PROCESS_INFORMATION prozessinfo3;
				STARTUPINFO startinfo3;
				startinfo3.cb = sizeof( STARTUPINFOW );
				ZeroMemory( &startinfo3, sizeof( STARTUPINFOW ) );
				DateiRemove( new Text( "data/tmp/keinabsturz" ) );

				if( CreateProcess( 0, "\"data/client/bin/game client.exe\"", 0, 0, 0, 0, 0, 0, &startinfo3, &prozessinfo3 ) == 1 )
				{
					CloseHandle( prozessinfo3.hThread );
					while( WaitForSingleObject( prozessinfo3.hProcess, 5000 ) == WAIT_TIMEOUT );
					CloseHandle( prozessinfo3.hProcess );
				}
				else
					WMessageBox( 0, new Text( "Fehler" ), new Text( "Das Spiel konnte nicht gestartet werden." ), MB_ICONERROR );
			}
		}
		CloseHandle( prozessinfo2.hProcess );
	}
	else
	{
		WMessageBox( 0, new Text( "Fehler" ), new Text( "Der Patcher konnte nicht gestartet werden." ), MB_ICONERROR );
	}
	if( DateiExistiert( new Text( "data/tmp/keinabsturz" ) ) )
		erhaltung->abmelden();
	erhaltung->trennen();
	erhaltung->warteAufThread( 5000 );
	erhaltung->release();

	klient = new Klient();
    Keys::getServerKey( &key, l, Keys::MAIN, Keys::SENDEN );
    klient->setSendeKey( key, l );
    delete[] key;
    Keys::getServerKey( &key, l, Keys::MAIN, Keys::EMPFANGEN );
    klient->setEmpfangKey( key, l );
    delete[] key;
	if( !klient->verbinde( port, ipT->getText() ) )
	{
		WMessageBox( 0, new Text( "Fehler" ), new Text( "Die Verbindung zum Server ist abgebrochen." ), MB_ICONERROR );
		ipT->release();
		klient->release();
		Network::Exit();
		delete[] netwSchlssel;
		return 0;
	}
	klient->sende( "\0", 1 ); // Verschlsselung aktivieren
	klient->sendeEncrypted( "\1", 1 );
	klient->sendeEncrypted( (char*)&klientNummer, 4 );
	klient->getNachrichtEncrypted( &serverReturn, 1 );
	if( serverReturn == 3 )
	{
		klient->getNachrichtEncrypted( &byte, 1 );
		char *message = new char[ byte + 1 ];
		message[ byte ] = 0;
		klient->getNachrichtEncrypted( message, byte );
		Text *nachricht = new Text( "Fehler whrend der Identifikation beim Server.\nServer Rckgabe:\n " );
		nachricht->append( message );
		WMessageBox( 0, new Text( "Server Fehler" ), nachricht, MB_ICONERROR );
		delete[]message;
	}
	else
	{
		klient->setSendeKey( netwSchlssel, netwSchlsselLn );
		klient->setEmpfangKey( netwSchlssel, netwSchlsselLn );
	}
	klient->sendeEncrypted( "\7", 1 );
	klient->getNachrichtEncrypted( &serverReturn, 1 );
	if( serverReturn == 3 )
	{
		klient->getNachrichtEncrypted( &byte, 1 );
		char *message = new char[ byte + 1 ];
		message[ byte ] = 0;
		klient->getNachrichtEncrypted( message, byte );
		Text *nachricht = new Text( "Fehler whrend der Abmeldung beim Server.\nServer Rckgabe:\n " );
		nachricht->append( message );
		WMessageBox( 0, new Text( "Server Fehler" ), nachricht, MB_ICONERROR );
		delete[]message;
	}
	klient->sendeEncrypted( "\3", 1 );
	klient->getNachrichtEncrypted( &serverReturn, 1 );
	klient->trenne();
	ipT->release();
	klient->release();
	Network::Exit();

	DateiRemove( new Text( "data/tmp" ) );

	delete[] netwSchlssel;

	return 0;
}